<?php

namespace App\Controller;

use App\Container;
use App\Router\Request\IRequest;
use App\Router\Response\Response;
use Manager\ActivityManager;
use Shared\Attributes\Route;
use Twig\Environment;
use Data\Core\Preferences;
use Shared\Log;

class HeartRateController extends BaseController
{

    private ActivityManager $activityMgr;

    public function __construct(ActivityManager $manager)
    {
        parent::__construct();
        $this->activityMgr = $manager;
    }

    #[Route(path: '/import', name: 'import', methods: ['GET'])]
    public function import(): Response
    {
        return $this->render('./page/import.html.twig', [
            'css' => $this->preference->getCookie(),
            'pp' => "test2",
            'user' => "Doe",
            'role' => "Athlète",
            'friendship' => [],
            'analyzes' => [],
            'mails' => [],
            'users' => [],
            'infoUser' => [],
            'exos' => [],
            'member' => []
        ]);
    }

    #[Route(path: '/upload', name: 'upload', methods: ['POST'])]
    public function uploadFile(string $activityType, int $effort, IRequest $req): Response
    {
        $error = [];
        /*$fileType = strtolower(pathinfo($_FILES["uploaded_file"]["name"], PATHINFO_EXTENSION));
        if (!$fileType == "fit") {
            $error [] = "";
        }*/
        // Validate effort
        if ($effort < 0 || $effort > 5) {
            $error [] = 'Invalid effort level.';
            $resp = new Response('Invalid effort level.', 400);
            return $this->render('./page/import.html.twig', [
                'css' => $this->preference->getCookie(),
                'pp' => "test2",
                'user' => "Doe",
                'role' => "Athlète",
                'friendship' => [],
                'analyzes' => [],
                'mails' => [],
                'users' => [],
                'infoUser' => [],
                'exos' => [],
                'member' => [],
                'error' => $error
            ], $resp);
        }


        /*        $error [] = 'Le fichier doit être de type d\'une taille inferieur à 10 MB.';*/

        // Move the file to the directory where files are stored
        try {
            $tmp_file = $_FILES['uploaded_file']['tmp_name'];
            if(file_exists($tmp_file)) {
                $fileExtension = pathinfo($_FILES['uploaded_file']['name'], PATHINFO_EXTENSION);
                if ($fileExtension === 'fit') {
                    $content = file_get_contents($tmp_file);
                    if ($this->activityMgr->uploadFile($activityType, 5, $content)) {
                        /////////////
                        return $this->render('./page/home.html.twig', [
                            'css' => $this->preference->getCookie(),
                        ]);
                    }else{
                        Log::dd('Ratter Model');

                    }
                }else{
                    Log::dd('Le fichier doit être de type .fit.');
                }

            }else{
                Log::dd("failed");
            }

        } catch (\Exception $e) {
            Log::dd($e);
            return new Response('File upload error.', 500);
        }

        return new Response('Invalid file type.', 400);
    }


}